//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Server.ObservableCommandTest
{
    
    
    /// <summary>
    /// This is a test feature to test observable commands.
    /// It specifies various observable commands and returns defined answers to validate against.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("ObservableCommandTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Observable Command Test")]
    public partial interface IObservableCommandTest
    {
        
        /// <summary>
        /// Count from 0 to N-1 and return the current number as intermediate response.
        /// </summary>
        /// <param name="n">Number to count to</param>
        /// <param name="delay">The delay for each iteration</param>
        /// <returns>The last number (N-1)</returns>
        [Tecan.Sila2.ObservableAttribute()]
        [return: Tecan.Sila2.SilaIdentifierAttribute("IterationResponse")]
        Tecan.Sila2.IIntermediateObservableCommand<long, long> Count(long n, [Tecan.Sila2.UnitAttribute("s", Second=1)] double delay);
        
        /// <summary>
        /// Echo the given value after the specified delay. The command state must be "waiting" until the delay has passed.
        /// </summary>
        /// <param name="value">The value to echo</param>
        /// <param name="delay">The delay before the command execution starts</param>
        /// <returns>The Received Value</returns>
        [Tecan.Sila2.ObservableAttribute()]
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        Tecan.Sila2.IObservableCommand<long> EchoValueAfterDelay(long value, [Tecan.Sila2.UnitAttribute("s", Second=1)] double delay);
    }
}
